Public Class ASPSMSNET
    Private ASPSMSX As New com.aspsms.webservice.ASPSMSSOAPWebService
    Private SMSXObj As New com.aspsms.webservice.cASPSMSX
    Private mUserKey As String
    Private mPassword As String
    Private mOriginator As String
    Private mOriginatorUnlockCode As String
    Private mDeferredDeliveryTime As String
    Private mMessageData As String
    Private mFlashingSMS As Boolean
    Private mBlinkingSMS As Boolean
    Private mReplaceMessage As Integer
    Private mURLBufferedMessageNotification As String
    Private mURLDeliveryNotification As String
    Private mURLNonDeliveryNotification As String
    Private mTimeZone As Integer
    Private mTimeOut As Integer
    Private mMMC As Integer
    Private mMNC As Integer
    Private mXSer As String
    Private mRecipients As New cRecipients
    Private mNotificationInquirySettings As New cNotificationInquirySettings
    Private mMessageWaitingIndicationSettings As New cMessageWaitingIndicationSettings
    Private mWAPPushSettings As New cWAPPushSettings
    Private mVCard As New cVCard
    Private mTRNsForNotificationInquiry As New cTRNs
    Private mLifeTime As Integer
    Private rErrorCode As Integer
    Private rErrorDescription As String

    Public Property UserKey() As String
        Get
            UserKey = mUserKey
        End Get
        Set(ByVal value As String)
            mUserKey = value
        End Set
    End Property
    Public Property Password() As String
        Get
            Password = mPassword
        End Get
        Set(ByVal value As String)
            mPassword = value
        End Set
    End Property
    Public Property Originator() As String
        Get
            Originator = mOriginator
        End Get
        Set(ByVal value As String)
            mOriginator = value
        End Set
    End Property
    Public Property OriginatorUnlockCode() As String
        Get
            OriginatorUnlockCode = mOriginatorUnlockCode
        End Get
        Set(ByVal value As String)
            mOriginatorUnlockCode = value
        End Set
    End Property
    Public Property DeferredDeliveryTime() As String
        Get
            DeferredDeliveryTime = mDeferredDeliveryTime
        End Get
        Set(ByVal value As String)
            mDeferredDeliveryTime = value
        End Set
    End Property
    Public Property MessageData() As String
        Get
            MessageData = mMessageData
        End Get
        Set(ByVal value As String)
            mMessageData = value
        End Set
    End Property
    Public Property FlashingSMS() As Boolean
        Get
            FlashingSMS = mFlashingSMS
        End Get
        Set(ByVal value As Boolean)
            mFlashingSMS = value
        End Set
    End Property
    Public Property BlinkingSMS() As Boolean
        Get
            BlinkingSMS = mBlinkingSMS
        End Get
        Set(ByVal value As Boolean)
            mBlinkingSMS = value
        End Set
    End Property
    Public Property ReplaceMessage() As Integer
        Get
            ReplaceMessage = mReplaceMessage
        End Get
        Set(ByVal value As Integer)
            mReplaceMessage = value
        End Set
    End Property
    Public Property URLBufferedMessageNotification() As String
        Get
            URLBufferedMessageNotification = mURLBufferedMessageNotification
        End Get
        Set(ByVal value As String)
            mURLBufferedMessageNotification = value
        End Set
    End Property
    Public Property URLDeliveryNotification() As String
        Get
            URLDeliveryNotification = mURLDeliveryNotification
        End Get
        Set(ByVal value As String)
            mURLDeliveryNotification = value
        End Set
    End Property
    Public Property URLNonDeliveryNotification() As String
        Get
            URLNonDeliveryNotification = mURLNonDeliveryNotification
        End Get
        Set(ByVal value As String)
            mURLNonDeliveryNotification = value
        End Set
    End Property
    Public Property TimeOut() As Integer
        Get
            TimeOut = mTimeOut
        End Get
        Set(ByVal value As Integer)
            mTimeOut = value
        End Set
    End Property
    Public Property TimeZone() As Integer
        Get
            TimeZone = mTimeZone
        End Get
        Set(ByVal value As Integer)
            mTimeZone = value
        End Set
    End Property
    Public Property Recipients() As cRecipients
        Get
            Recipients = mRecipients
        End Get
        Set(ByVal value As cRecipients)
            mRecipients = value
        End Set
    End Property
    Public Property NotificationInquirySettings() As cNotificationInquirySettings
        Get
            NotificationInquirySettings = mNotificationInquirySettings
        End Get
        Set(ByVal value As cNotificationInquirySettings)
            mNotificationInquirySettings = value
        End Set
    End Property
    Public Property MessageWaitingIndicationSettings() As cMessageWaitingIndicationSettings
        Get
            MessageWaitingIndicationSettings = mMessageWaitingIndicationSettings
        End Get
        Set(ByVal value As cMessageWaitingIndicationSettings)
            mMessageWaitingIndicationSettings = value
        End Set
    End Property
    Public Property VCard() As cVCard
        Get
            VCard = mVCard
        End Get
        Set(ByVal value As cVCard)
            mVCard = value
        End Set
    End Property
    Public Property MMC() As Integer
        Get
            MMC = mMMC
        End Get
        Set(ByVal value As Integer)
            mMMC = value
        End Set
    End Property
    Public Property MNC() As Integer
        Get
            MNC = mMNC
        End Get
        Set(ByVal value As Integer)
            mMNC = value
        End Set
    End Property
    Public Property XSer() As String
        Get
            XSer = mXSer
        End Get
        Set(ByVal value As String)
            mXSer = value
        End Set
    End Property
    Public Property TRNsForNotificationInquiry() As cTRNs
        Get
            TRNsForNotificationInquiry = mTRNsForNotificationInquiry
        End Get
        Set(ByVal value As cTRNs)
            mTRNsForNotificationInquiry = value
        End Set
    End Property
    Public Property LifeTime() As Integer
        Get
            LifeTime = mLifeTime
        End Get
        Set(ByVal value As Integer)
            mLifeTime = value
        End Set
    End Property
    Public Property WAPPushSettings() As cWAPPushSettings
        Get
            WAPPushSettings = mWAPPushSettings
        End Get
        Set(ByVal value As cWAPPushSettings)
            mWAPPushSettings = value
        End Set
    End Property
    Public ReadOnly Property ErrorCode() As Integer
        Get
            ErrorCode = rErrorCode
        End Get
    End Property
    Public ReadOnly Property ErrorDescription() As String
        Get
            ErrorDescription = rErrorDescription
        End Get
    End Property

    Public Sub SendTextSMS()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_TextSMS
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendPictureMessage()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_PictureMessage
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendLogo()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_Logo
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendGroupLogo()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_GroupLogo
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendRingtone()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_Ringtone
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendVCard()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_VCard
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendBinaryData()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_BinaryData
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendMessageWaitingIndication()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_MessageWaitingIndication
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendRandomLogo()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_RandomLogo
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Function InquireDeliveryNotifications() As String
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_InquireDeliveryNotifications
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
        InquireDeliveryNotifications = R.AdditionalData
    End Function
    Public Sub CheckOriginatorAuthorization()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_CheckOriginatorAuthorization
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub SendOriginatorUnlockCode()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_SendOriginatorUnlockCode
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Sub UnlockOriginator()
        Dim R As com.aspsms.webservice.cResult
        Call SetAll()
        SMSXObj.Operation = com.aspsms.webservice.ASPSMSX_Operation.OP_UnlockOriginator
        R = ASPSMSX.PutASPSMSXObj(SMSXObj)
        rErrorCode = R.ErrorCode
        rErrorDescription = R.ErrorDescription
    End Sub
    Public Function CheckCredits() As Single
        CheckCredits = CSng(ASPSMSX.CheckCredits(mUserKey, mPassword))
    End Function

    Private Sub SetAll()
        Call SetCredentials()
        Call SetUserSettings()
        Call AddRecipients()
        Call AddTRNs()
    End Sub

    Private Sub SetUserSettings()
        With SMSXObj
            .BlinkingSMS = mBlinkingSMS
            .DeferredDeliveryTime = mDeferredDeliveryTime
            .FlashingSMS = mFlashingSMS
            .LifeTime = mLifeTime
            .MessageData = mMessageData
            .MMC = mMMC
            .MNC = mMNC
            .Originator = mOriginator
            .OriginatorUnlockCode = mOriginatorUnlockCode
            .ReplaceMessage = mReplaceMessage
            .TimeOut = mTimeOut
            .TimeZone = mTimeZone
            .URLBufferedMessageNotification = mURLBufferedMessageNotification
            .URLDeliveryNotification = mURLDeliveryNotification
            .URLNonDeliveryNotification = mURLNonDeliveryNotification
            .XSer = mXSer
            Dim i As Integer
            i = mMessageWaitingIndicationSettings.CountEmailMessages
            .MessageWaitingIndicationSettings.CountEmailMessages = i
            .MessageWaitingIndicationSettings.CountFaxMessages = mMessageWaitingIndicationSettings.CountFaxMessages
            .MessageWaitingIndicationSettings.CountOtherMessages = mMessageWaitingIndicationSettings.CountOtherMessages
            .MessageWaitingIndicationSettings.CountVoiceMessages = mMessageWaitingIndicationSettings.CountVoiceMessages
            .MessageWaitingIndicationSettings.EMailIndication = mMessageWaitingIndicationSettings.EMailIndication
            .MessageWaitingIndicationSettings.FaxIndication = mMessageWaitingIndicationSettings.FaxIndication
            .MessageWaitingIndicationSettings.OtherIndication = mMessageWaitingIndicationSettings.OtherIndication
            .MessageWaitingIndicationSettings.StoreMessage = mMessageWaitingIndicationSettings.StoreMessage
            .MessageWaitingIndicationSettings.VoiceIndication = mMessageWaitingIndicationSettings.VoiceIndication
            .NotificationInquirySettings.Format = mNotificationInquirySettings.Format
            .NotificationInquirySettings.Separator = mNotificationInquirySettings.Separator
            .VCard.Name = mVCard.Name
            .VCard.PhoneNumber = mVCard.PhoneNumber
            .WAPPushSettings.Description = mWAPPushSettings.Description
            .WAPPushSettings.URL = mWAPPushSettings.URL
        End With
    End Sub

    Private Sub SetCredentials()
        SMSXObj.UserKey = mUserKey
        SMSXObj.Password = mPassword
    End Sub
    Private Sub AddRecipients()
        Dim Rcpt As cRecipient
        For Each Rcpt In mRecipients
            If Rcpt.TransactionReferenceNumber = 0 Then
                SMSXObj.Recipients = SMSXObj.Recipients & Rcpt.SubscriberNumber & ";"
            Else
                SMSXObj.Recipients = SMSXObj.Recipients & Rcpt.SubscriberNumber & "," & Rcpt.TransactionReferenceNumber & ";"
            End If
        Next
    End Sub
    Private Sub AddTRNs()
        Dim TRN As String
        For Each TRN In mTRNsForNotificationInquiry
            SMSXObj.TRNsForNotificationInquiry = SMSXObj.TRNsForNotificationInquiry & TRN & ";"
        Next
    End Sub

    Public Sub New()
        SMSXObj.MessageWaitingIndicationSettings = New com.aspsms.webservice.cMessageWaitingIndicationSettings
        SMSXObj.NotificationInquirySettings = New com.aspsms.webservice.cNotificationInquirySettings
        SMSXObj.VCard = New com.aspsms.webservice.cVCard
        SMSXObj.WAPPushSettings = New com.aspsms.webservice.cWAPPushSettings
    End Sub
End Class
